blob: ebf40f6edb4d4ee5f847a103cb082bcddec99dd6 [file] [log] [blame]
Linus Torvalds1da177e2005-04-16 15:20:36 -07001# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
Steven Rostedt03fa25d2009-04-29 22:52:22 -04005PHONY += oldconfig xconfig gconfig menuconfig config silentoldconfig update-po-config \
Steven Rostedt281c9da2009-04-29 22:52:23 -04006 localmodconfig localyesconfig
Linus Torvalds1da177e2005-04-16 15:20:36 -07007
Al Viro61bee202008-08-25 04:51:27 -04008ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
Arnaud Lacombe838a2e52010-09-04 17:10:20 -040011Kconfig := Kconfig
Al Viro61bee202008-08-25 04:51:27 -040012endif
Sam Ravnborge703f752007-10-25 20:42:18 +020013
Yann E. MORINc2838e62012-11-22 01:06:04 +010014# We need this, in case the user has it in its environment
15unexport CONFIG_
16
Linus Torvalds1da177e2005-04-16 15:20:36 -070017xconfig: $(obj)/qconf
Sam Ravnborge703f752007-10-25 20:42:18 +020018 $< $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070019
20gconfig: $(obj)/gconf
Sam Ravnborge703f752007-10-25 20:42:18 +020021 $< $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070022
23menuconfig: $(obj)/mconf
Sam Ravnborge703f752007-10-25 20:42:18 +020024 $< $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070025
26config: $(obj)/conf
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020027 $< --oldaskconfig $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070028
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +020029nconfig: $(obj)/nconf
30 $< $(Kconfig)
31
Linus Torvalds1da177e2005-04-16 15:20:36 -070032oldconfig: $(obj)/conf
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020033 $< --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070034
35silentoldconfig: $(obj)/conf
Masahiro Yamada98155942014-05-29 14:33:03 +090036 $(Q)mkdir -p include/config include/generated
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020037 $< --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070038
Arnaud Lacombe50bce3e2011-07-01 18:13:03 -040039localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
Masahiro Yamada98155942014-05-29 14:33:03 +090040 $(Q)mkdir -p include/config include/generated
Arnaud Lacombe22d550a2011-07-20 00:40:09 -040041 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
Michal Marek7a996d32010-08-04 14:05:07 +020042 $(Q)if [ -f .config ]; then \
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020043 cmp -s .tmp.config .config || \
44 (mv -f .config .config.old.1; \
45 mv -f .tmp.config .config; \
46 $(obj)/conf --silentoldconfig $(Kconfig); \
47 mv -f .config.old.1 .config.old) \
48 else \
49 mv -f .tmp.config .config; \
50 $(obj)/conf --silentoldconfig $(Kconfig); \
Steven Rostedta7c02602009-05-07 11:09:55 -040051 fi
Steven Rostedt03fa25d2009-04-29 22:52:22 -040052 $(Q)rm -f .tmp.config
53
EGRY Gabor10200262008-01-11 23:40:00 +010054# Create new linux.pot file
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020055# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
EGRY Gabor46d26312008-01-11 23:46:11 +010056update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
Peter Foleye2aef4d2011-12-18 18:15:16 -050057 $(Q)echo " GEN config.pot"
Peter Foleya24a1b82011-04-26 18:13:05 -040058 $(Q)xgettext --default-domain=linux \
59 --add-comments --keyword=_ --keyword=N_ \
60 --from-code=UTF-8 \
61 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
62 --directory=$(srctree) --directory=$(objtree) \
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020063 --output $(obj)/config.pot
64 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
Paul Bollefa0ad6572011-11-05 12:21:30 +010065 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
66 $(srctree)/arch/*/um/Kconfig`; \
EGRY Gabor10200262008-01-11 23:40:00 +010067 do \
Peter Foleye2aef4d2011-12-18 18:15:16 -050068 echo " GEN $$i"; \
Sam Ravnborg42175162008-04-25 21:15:41 +020069 $(obj)/kxgettext $$i \
EGRY Gabor10200262008-01-11 23:40:00 +010070 >> $(obj)/config.pot; \
71 done )
Peter Foleye2aef4d2011-12-18 18:15:16 -050072 $(Q)echo " GEN linux.pot"
EGRY Gabor10200262008-01-11 23:40:00 +010073 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020074 --output $(obj)/linux.pot
Sam Ravnborgb70e325c2007-06-10 20:38:27 +020075 $(Q)rm -f $(obj)/config.pot
Arnaldo Carvalho de Melo3b9fa092005-05-05 15:09:46 -070076
Sam Ravnborg0748cb32010-07-31 23:35:31 +020077PHONY += allnoconfig allyesconfig allmodconfig alldefconfig randconfig
Linus Torvalds1da177e2005-04-16 15:20:36 -070078
Sam Ravnborg0748cb32010-07-31 23:35:31 +020079allnoconfig allyesconfig allmodconfig alldefconfig randconfig: $(obj)/conf
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020080 $< --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070081
Adam Leefb16d892012-09-01 01:05:17 +080082PHONY += listnewconfig olddefconfig oldnoconfig savedefconfig defconfig
Linus Torvalds1da177e2005-04-16 15:20:36 -070083
Adam Leefb16d892012-09-01 01:05:17 +080084listnewconfig olddefconfig: $(obj)/conf
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020085 $< --$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070086
Adam Leefb16d892012-09-01 01:05:17 +080087# oldnoconfig is an alias of olddefconfig, because people already are dependent
88# on its behavior(sets new symbols to their default value but not 'n') with the
89# counter-intuitive name.
90oldnoconfig: $(obj)/conf
91 $< --olddefconfig $(Kconfig)
92
Sam Ravnborg7cf3d732010-07-31 23:35:34 +020093savedefconfig: $(obj)/conf
94 $< --$@=defconfig $(Kconfig)
95
Linus Torvalds1da177e2005-04-16 15:20:36 -070096defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
Sam Ravnborg4062f1a2010-07-31 23:35:26 +020098 $< --defconfig $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -070099else
Sam Ravnborg2266cfd2007-10-25 20:31:19 +0200100 @echo "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
Sam Ravnborg4062f1a2010-07-31 23:35:26 +0200101 $(Q)$< --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700102endif
103
104%_defconfig: $(obj)/conf
Sam Ravnborg4062f1a2010-07-31 23:35:26 +0200105 $(Q)$< --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700106
Josh Triplett3aaefce2014-08-06 15:21:00 -0700107configfiles=$(wildcard $(srctree)/kernel/configs/$(1).config $(srctree)/arch/$(SRCARCH)/configs/$(1).config)
108
109define mergeconfig
110$(if $(wildcard $(objtree)/.config),, $(error You need an existing .config for this target))
111$(if $(call configfiles,$(1)),, $(error No configuration exists for this target on this architecture))
112$(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m -O $(objtree) $(objtree)/.config $(call configfiles,$(1))
113$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
114endef
115
116PHONY += kvmconfig
117kvmconfig:
118 $(call mergeconfig,kvm_guest)
119
Josh Triplett0da1d4a2014-08-08 16:25:47 -0700120PHONY += tinyconfig
121tinyconfig: allnoconfig
122 $(call mergeconfig,tiny)
123
Linus Torvalds1da177e2005-04-16 15:20:36 -0700124# Help text used by make help
125help:
126 @echo ' config - Update current config utilising a line-oriented program'
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200127 @echo ' nconfig - Update current config utilising a ncurses menu based program'
Linus Torvalds1da177e2005-04-16 15:20:36 -0700128 @echo ' menuconfig - Update current config utilising a menu based program'
129 @echo ' xconfig - Update current config utilising a QT based front-end'
130 @echo ' gconfig - Update current config utilising a GTK based front-end'
131 @echo ' oldconfig - Update current config utilising a provided .config as base'
Steven Rostedt03fa25d2009-04-29 22:52:22 -0400132 @echo ' localmodconfig - Update current config disabling modules not loaded'
Steven Rostedt281c9da2009-04-29 22:52:23 -0400133 @echo ' localyesconfig - Update current config converting local mods to core'
Markus Heidelberg590a5852009-05-18 01:36:46 +0200134 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
Sam Ravnborg0748cb32010-07-31 23:35:31 +0200135 @echo ' defconfig - New config with default from ARCH supplied defconfig'
Sam Ravnborg7cf3d732010-07-31 23:35:34 +0200136 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
Jesper Juhle11f0492006-02-25 21:52:50 +0100137 @echo ' allnoconfig - New config where all options are answered with no'
Sam Ravnborg0748cb32010-07-31 23:35:31 +0200138 @echo ' allyesconfig - New config where all options are accepted with yes'
139 @echo ' allmodconfig - New config selecting modules when possible'
140 @echo ' alldefconfig - New config with all symbols set to default'
141 @echo ' randconfig - New config with random answer to all options'
Sam Ravnborg861b4ea2010-07-31 23:35:28 +0200142 @echo ' listnewconfig - List new options'
Adam Leefb16d892012-09-01 01:05:17 +0800143 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their default value'
Josh Triplett3aaefce2014-08-06 15:21:00 -0700144 @echo ' kvmconfig - Enable additional options for guest kernel support'
Josh Triplett0da1d4a2014-08-08 16:25:47 -0700145 @echo ' tinyconfig - Configure the tiniest possible kernel'
Linus Torvalds1da177e2005-04-16 15:20:36 -0700146
Sam Ravnborg2982de62006-07-27 22:10:27 +0200147# lxdialog stuff
148check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
149
Rob Landleye9e40e12007-10-15 19:23:12 -0500150# Use recursively expanded variables so we do not call gcc unless
Sam Ravnborg2982de62006-07-27 22:10:27 +0200151# we really need to do so. (Do not call gcc as part of make mrproper)
Arnaud Lacombe9ba95682010-08-22 20:03:06 -0400152HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
153 -DLOCALE
Sam Ravnborg2982de62006-07-27 22:10:27 +0200154
Linus Torvalds1da177e2005-04-16 15:20:36 -0700155# ===========================================================================
156# Shared Makefile for the various kconfig executables:
157# conf: Used for defconfig, oldconfig and related targets
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200158# nconf: Used for the nconfig target.
159# Utilizes ncurses
Markus Heidelberg6f26e5e2009-05-18 01:36:45 +0200160# mconf: Used for the menuconfig target
Linus Torvalds1da177e2005-04-16 15:20:36 -0700161# Utilizes the lxdialog package
162# qconf: Used for the xconfig target
163# Based on QT which needs to be installed to compile it
164# gconf: Used for the gconfig target
165# Based on GTK which needs to be installed to compile it
166# object files used by all kconfig flavours
167
Sam Ravnborg2982de62006-07-27 22:10:27 +0200168lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
169lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
170
Linus Torvalds1da177e2005-04-16 15:20:36 -0700171conf-objs := conf.o zconf.tab.o
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200172mconf-objs := mconf.o zconf.tab.o $(lxdialog)
173nconf-objs := nconf.o zconf.tab.o nconf.gui.o
Arnaldo Carvalho de Melo3b9fa092005-05-05 15:09:46 -0700174kxgettext-objs := kxgettext.o zconf.tab.o
Peter Foleyf1943042011-04-26 18:00:05 -0400175qconf-cxxobjs := qconf.o
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400176qconf-objs := zconf.tab.o
177gconf-objs := gconf.o zconf.tab.o
Linus Torvalds1da177e2005-04-16 15:20:36 -0700178
Peter Foleyd02ab882011-04-26 18:02:08 -0400179hostprogs-y := conf
Sam Ravnborgc29121b2006-09-02 21:32:14 +0200180
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200181ifeq ($(MAKECMDGOALS),nconfig)
182 hostprogs-y += nconf
183endif
184
Sam Ravnborgc29121b2006-09-02 21:32:14 +0200185ifeq ($(MAKECMDGOALS),menuconfig)
186 hostprogs-y += mconf
187endif
188
Peter Foley1f594712011-04-26 17:57:38 -0400189ifeq ($(MAKECMDGOALS),update-po-config)
190 hostprogs-y += kxgettext
191endif
192
Linus Torvalds1da177e2005-04-16 15:20:36 -0700193ifeq ($(MAKECMDGOALS),xconfig)
194 qconf-target := 1
195endif
196ifeq ($(MAKECMDGOALS),gconfig)
197 gconf-target := 1
198endif
199
200
201ifeq ($(qconf-target),1)
Peter Foleyf1943042011-04-26 18:00:05 -0400202 hostprogs-y += qconf
Linus Torvalds1da177e2005-04-16 15:20:36 -0700203endif
204
205ifeq ($(gconf-target),1)
Peter Foleyd02ab882011-04-26 18:02:08 -0400206 hostprogs-y += gconf
Linus Torvalds1da177e2005-04-16 15:20:36 -0700207endif
208
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400209clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
Arnaud Lacombe2f76b352011-05-23 01:08:19 -0400210clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
nir.tzachar@gmail.com692d97c2009-11-25 12:28:43 +0200211clean-files += mconf qconf gconf nconf
EGRY Gabor10200262008-01-11 23:40:00 +0100212clean-files += config.pot linux.pot
Linus Torvalds1da177e2005-04-16 15:20:36 -0700213
Sam Ravnborg6e588f62007-12-09 20:11:15 +0100214# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
215PHONY += $(obj)/dochecklxdialog
216$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
217$(obj)/dochecklxdialog:
Arnaud Lacombe7080e472010-08-16 00:19:04 -0400218 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
Sam Ravnborg6e588f62007-12-09 20:11:15 +0100219
220always := dochecklxdialog
221
Sam Ravnborgaa1e5ef2007-08-12 23:15:44 +0200222# Add environment specific flags
223HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
Yuri Vasilevski70a6a0c2005-10-30 15:03:20 -0800224
Linus Torvalds1da177e2005-04-16 15:20:36 -0700225# generated files seem to need this to find local include files
Arnaud Lacombe2f76b352011-05-23 01:08:19 -0400226HOSTCFLAGS_zconf.lex.o := -I$(src)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700227HOSTCFLAGS_zconf.tab.o := -I$(src)
228
Arnaud Lacombe378dbb22011-05-23 02:08:52 -0400229LEX_PREFIX_zconf := zconf
230YACC_PREFIX_zconf := zconf
231
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400232HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
233HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700234
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400235HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
Adrian Bunk37193142006-01-02 11:25:30 +0100236HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
Arnaud Lacombe1ea3ad42011-06-05 23:36:05 -0400237 -Wno-missing-prototypes
Linus Torvalds1da177e2005-04-16 15:20:36 -0700238
Arnaud Lacombe7080e472010-08-16 00:19:04 -0400239HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
240
Justin Lecher544e7e52013-03-06 14:02:02 +0100241HOSTLOADLIBES_nconf = $(shell \
242 pkg-config --libs menu panel ncurses 2>/dev/null \
243 || echo "-lmenu -lpanel -lncurses" )
Linus Torvalds1da177e2005-04-16 15:20:36 -0700244$(obj)/qconf.o: $(obj)/.tmp_qtcheck
245
246ifeq ($(qconf-target),1)
Roman Zippelb3a52252005-11-21 21:32:38 -0800247$(obj)/.tmp_qtcheck: $(src)/Makefile
Linus Torvalds1da177e2005-04-16 15:20:36 -0700248-include $(obj)/.tmp_qtcheck
249
250# QT needs some extra effort...
251$(obj)/.tmp_qtcheck:
Roman Zippelb3a52252005-11-21 21:32:38 -0800252 @set -e; echo " CHECK qt"; dir=""; pkg=""; \
Alexander Stein133c5f72010-08-31 17:34:37 +0200253 if ! pkg-config --exists QtCore 2> /dev/null; then \
254 echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
255 pkg-config --exists qt 2> /dev/null && pkg=qt; \
256 pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
257 if [ -n "$$pkg" ]; then \
258 cflags="\$$(shell pkg-config $$pkg --cflags)"; \
259 libs="\$$(shell pkg-config $$pkg --libs)"; \
260 moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
261 dir="$$(pkg-config $$pkg --variable=prefix)"; \
262 else \
263 for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
264 if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
265 done; \
266 if [ -z "$$dir" ]; then \
Michal Marek5b580fa2012-07-07 23:32:18 +0200267 echo >&2 "*"; \
268 echo >&2 "* Unable to find any QT installation. Please make sure that"; \
269 echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
270 echo >&2 "* either qmake can be found or install pkg-config or set"; \
271 echo >&2 "* the QTDIR environment variable to the correct location."; \
272 echo >&2 "*"; \
Alexander Stein133c5f72010-08-31 17:34:37 +0200273 false; \
274 fi; \
275 libpath=$$dir/lib; lib=qt; osdir=""; \
276 $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
277 osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
278 test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
279 test -f $$libpath/libqt-mt.so && lib=qt-mt; \
280 cflags="-I$$dir/include"; \
281 libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
282 moc="$$dir/bin/moc"; \
283 fi; \
284 if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
285 echo "*"; \
286 echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
287 echo "*"; \
288 moc="/usr/bin/moc"; \
289 fi; \
Sam Ravnborgab919c02005-11-06 11:05:21 +0100290 else \
Michal Marek458452f2010-09-13 13:41:31 +0200291 cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
292 libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
Yaakov Selkowitz48485942012-07-04 15:23:29 -0500293 moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
294 [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
Roman Zippelb3a52252005-11-21 21:32:38 -0800295 fi; \
296 echo "KC_QT_CFLAGS=$$cflags" > $@; \
297 echo "KC_QT_LIBS=$$libs" >> $@; \
298 echo "KC_QT_MOC=$$moc" >> $@
Linus Torvalds1da177e2005-04-16 15:20:36 -0700299endif
300
301$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
302
303ifeq ($(gconf-target),1)
304-include $(obj)/.tmp_gtkcheck
305
306# GTK needs some extra effort, too...
307$(obj)/.tmp_gtkcheck:
Adrian Bunk37193142006-01-02 11:25:30 +0100308 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
309 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700310 touch $@; \
311 else \
Michal Marek5b580fa2012-07-07 23:32:18 +0200312 echo >&2 "*"; \
313 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
314 echo >&2 "*"; \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700315 false; \
316 fi \
317 else \
Michal Marek5b580fa2012-07-07 23:32:18 +0200318 echo >&2 "*"; \
319 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
320 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
321 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
322 echo >&2 "*"; \
Linus Torvalds1da177e2005-04-16 15:20:36 -0700323 false; \
324 fi
325endif
326
Arnaud Lacombe2f76b352011-05-23 01:08:19 -0400327$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
Linus Torvalds1da177e2005-04-16 15:20:36 -0700328
Arnaud Lacombe5a6f8d22011-06-01 16:14:47 -0400329$(obj)/qconf.o: $(obj)/qconf.moc
Linus Torvalds1da177e2005-04-16 15:20:36 -0700330
Yaakov Selkowitzebca0262012-07-04 18:31:11 -0500331quiet_cmd_moc = MOC $@
332 cmd_moc = $(KC_QT_MOC) -i $< -o $@
333
334$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
335 $(call cmd,moc)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700336
EGRY Gabor46d26312008-01-11 23:46:11 +0100337# Extract gconf menu items for I18N support
338$(obj)/gconf.glade.h: $(obj)/gconf.glade
Peter Foley2d80eb02011-04-26 18:16:53 -0400339 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
Peter Foleya24a1b82011-04-26 18:13:05 -0400340 $(obj)/gconf.glade